#------------------------------------------------------------------------------
#$Author: andrius $
#$Date: 2015-05-06 09:28:49 +0200 (Wed, 06 May 2015) $ 
#$Revision: 3369 $
#$URL: svn://www.crystallography.net/cod-tools/trunk/src/lib/perl5/COD/CIF2JSON.pm $
#------------------------------------------------------------------------------
#*
#  Serializes and deserializes CIF data structures, generated by COD CIF
#  parsers, to/from JSON format.
#**

package COD::CIF2JSON;

use strict;
use warnings;

require Exporter;
our @ISA = qw(Exporter);
our @EXPORT = qw(
    cif2json json2cif
);

my $format_version = 1.0;

use JSON;

sub cif2json($)
{
    my( $data ) = @_;
    return encode_json( { data => $data,
                          version => sprintf "%2.1f", $format_version } );
}

sub json2cif($)
{
    my( $json ) = @_;
    my $decoded = decode_json( $json );
    if( !exists $decoded->{version} ) {
        die "unknown serialization format version, will not deserialize";
    }
    my( $our_major )   = split( '\.', $format_version );
    my( $their_major ) = split( '\.', $decoded->{version} );
    if( $our_major != $their_major ) {
        die "major versions of used serialization format and the " .
            "deserializer are different (current: $our_major, used: " .
            "$their_major), will not deserialize";
    }
    return $decoded->{data};
}
